import org.apache.nifi.components.PropertyDescriptor
import org.apache.nifi.components.ValidationContext
import org.apache.nifi.components.ValidationResult
import org.apache.nifi.logging.ComponentLog
import org.apache.nifi.processor.*
import org.apache.nifi.processor.exception.ProcessException

class E {

    void executeScript(ProcessSession session, ProcessContext context, ComponentLog log, Relationship REL_SUCCESS, Relationship REL_FAILURE) {
        def flowFile = session.get()
        if (!flowFile) {
            return
        }
        try {
            flowFile = session.putAttribute(flowFile, 'myAttr', 'Demo InvokeScriptedProcessor1')

            session.transfer(flowFile, REL_SUCCESS)
        } catch (e) {
            log.error('Error on executing script', e)
            session.transfer(flowFile, REL_FAILURE)
        }
    }

}

class GroovyProcessor implements Processor {
    Relationship REL_SUCCESS = new Relationship.Builder().name("success").description('FlowFiles that were successfully processed are routed here').build()
    Relationship REL_FAILURE = new Relationship.Builder().name("failure").description('FlowFiles that were not successfully processed are routed here').build()
    ComponentLog log
    def e = new E()

    @Override
    void initialize(ProcessorInitializationContext context) {
        log = context.logger
    }

    @Override
    Set<Relationship> getRelationships() {
        return [REL_FAILURE, REL_SUCCESS] as Set
    }

    @Override
    Collection<ValidationResult> validate(ValidationContext context) {
        null
    }

    @Override
    PropertyDescriptor getPropertyDescriptor(String name) {
        null
    }

    @Override
    void onPropertyModified(PropertyDescriptor descriptor, String oldValue, String newValue) {}

    @Override
    List<PropertyDescriptor> getPropertyDescriptors() {
        null
    }

    @Override
    String getIdentifier() {
        null
    }

    void setLogger(ComponentLog log) {
        this.log = log
    }

    @Override
    void onTrigger(ProcessContext context, ProcessSessionFactory sessionFactory) throws ProcessException {
        def session = sessionFactory.createSession()
        try {
            e.executeScript(session, context, log, REL_SUCCESS, REL_FAILURE)
            session.commit()
        } catch (final Throwable t) {
            log.error('{} failed to process due to {}; rolling back session', [this, t] as Object[])
            session.rollback(true)
            throw t
        }
    }
}

processor = new GroovyProcessor()
